#include <stdio.h>
#include <math.h>
#include "wsc.h"
#include "const.h"

/* numgpt: number of unknowns in horizontal direction */

void add_dmat_(float *ata, float *matr, float *math, float *weight, int* nd, int *nh)
{
int i, j, k, numatd, numgpt;
int ir1, ir2, ii,jj,kk, indr,indh;
  
  numatd=*nd;
  numgpt=*nh;
  
  printf(" numatd=%d\n",numatd);
  printf(" numgpt=%d\n",numgpt);
  printf("Weight A= %g B=%g C=%g\n",weight[0],weight[1], weight[2]);

/*
 add damping matrix
*/
  for(k=0,i=0;i<numatd;i++){
      ir1=i/numgpt;
      ii=i%numgpt;
      for(j=0;j<=i;j++,k++){
          ir2=j/numgpt;
          indr=(ir1+1)*ir1/2+ir2;

          if(ir1==ir2){		/* same radial order */
             jj=j%numgpt;
             indh=(ii+1)*ii/2+jj;
             ata[k]+=weight[0]*(weight[1]*math[indh]+weight[2]*matr[indr]);
          }else{
             ata[k]+=weight[0]*weight[2]*matr[indr];
	  }
      }
  }
}

